<?php
session_start();
	//start the session

	//include helper files
require_once("loginHelpers.php");
require_once("inputHelper.php");
$form_username;
$form_password;
$form_email;
$status;
$myerr;	
	
	//declare variables for this form/page
	
	//check if we've submitted the page, and if so, get the user data from the form
	if(isset($_POST['submit'])){
		$form_username = $_POST['user'];
		$form_password = $_POST['pw'];
		$form_email = $_POST['email'];
	
		//validate 
		if(!has_presence($form_username) || !has_presence($form_password)){
			$myerr = "Sorry, username and password cannot be empty  <br/>";
		}
		if (!filter_var($form_email, FILTER_VALIDATE_EMAIL)) {
  			$myerr = " Invalid email format <br/>"; 
		}

		if(!isset($myerr) && !has_length($form_username, ['min'=>4, 'max' =>30])){
			$myerr = "Sorry, name must be between 4 and 30 characters long  <br/>";
		}else if(!isset($myerr) && !has_length($form_password, ['min'=>6])){
			$myerr = "Sorry, password must be at least 6 characters long  <br/>";
		}
		
		//create account
		if(!isset($myerr) && createAccount($form_username, $form_password, $form_email)){
			$status = 1;
			$_SESSION['UserData']['Username'] = $form_username;
			header("location:startPage.php");
			exit;
		}else{
			$status = 0;
		}
		
	}
	
	
?>
<html>
<head><title>Register Page</title>
</head>
<body>
<header><nav>
<a href="startPage.php">Start Page</a>
<a href="protectedPage.php">Protected Page</a>
<a href="unprotectedPage.php">Unprotected Page</a>
</nav>
</header>
<h1>Register here</h1>
<form action="register.php" method="POST">
	<label for="user">User Name: </label>
	<input type="text" id="user" name="user" required="required"\>
	<label for="pw">Password </label>
	<input type="password" id="pw" name="pw" required="required"\>
	<label for="email">Email </label>
	<input type="text" id="email" name="email" required="required"\>
	<input type="submit" id="submit" name="submit" value="register"\>
</form>
<?php 
	//if register fails, show an error
	if(isset($myerr)){
		echo "error: ".$myerr."</br>";
	}else if($status === 0){
		echo "<p>Sorry, that name is already taken</p>";
	} 
?>
</body>
</html>