<?php
	require_once("../private/dbinfo.inc");
	require_once("../private/myFunctions.php");
	$err="no error";
	$msg = "no message";
	$title = "Sarah's Great Album Picker-doodle";
	if(isset($_POST['bandID'])){
		$title = sanitize($_POST['bandName'], "html") . "'s Super Awesome Albums";
	}
?>
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en" >
<head>
	<meta charset="utf-8"/>
	<title>Show Some Albums</title>
	<link rel="stylesheet" href="myStyles.css" type="text/css" />
</head>
<body>
<header>
	<h1><?php echo $title?></h1>
</header>
<?php 
	//if form not sent, build form
	if(!isset($_POST['bandID'])){
		echo "<form method='post' action='showAlbums.php'>\n";
		$myHandle;
		try{
			$myHandle = new PDO("mysql:host=$servername;dbname=$database", $username, $password);
			if($myHandle){
				$rslt = $myHandle->query("select bandName, bandID from bands order by bandName");
				$i = 0;
				foreach ($rslt as $row){
					foreach ($row as $field=>$value){
						$bands[$i][$field]= $value;
					}
					$i++;
				}
			}
			$numBands = sizeof($bands);
			echo "<select id='bandID' name='bandID' onchange='setName()'>\n";
			for($j=0; $j<$numBands; $j++){
				echo "<option value=\"{$bands[$j]['bandID']}\">{$bands[$j]['bandName']}</option>\n";
			}
			echo "</select>\n";
			echo "<input type='submit' value='Get Albums'/>\n";
			echo "<input type='hidden' id='bandName' name='bandName'/>\n";
			echo "</form>\n";
		}catch(PDOException $e){
			echo "Errors" . $e.getMessage();
		}
		
	}else{
		//don't need form, build a table
		echo "<div class='myTable'><div class='myRow'><span class='myCol'>Band</span><span class='myCol'>Album</span></div>\n";
		$myHandle;
		$bandID=sanitize($_POST['bandID'], "sql");
		try{
			$myHandle = new PDO("mysql:host=$servername;dbname=$database", $username, $password);
			if($myHandle && !is_null($bandID)){
				//$myStmt = "select bandName, albumName from bands left join albums on bands.bandID=albums.bandID where bands.bandID=$bandID and albums.bandID=$bandID";
				//echo $myStmt;
				//$rslt = $myHandle->query($myStmt);
				
				//alternatively use prepared query
				
				$myStmt = $myHandle->prepare("select bandName, albumName from bands left join albums on bands.bandID=albums.bandID where albums.bandID=:band_id AND bands.bandID=:band_id");
				if(is_null($myStmt)){
					echo "null statement\n";
				}
				$myStmt->bindParam(':band_id', $bandID);
				//$myStmt->bindParam('dd', $bandID, $bandID);
				$myStmt->execute();
				$rslt = $myStmt->fetchAll();
				//end prepared
				
				$i = 0;
				foreach ($rslt as $rowrow){
					foreach ($rowrow as $field=>$value){
						$albums[$i][$field]= $value;
					}
					$i++;
				}
				$numAlbums = sizeof($albums);
				for($j=0; $j<$numAlbums; $j++){
					echo "<div class='myRow'>";
					//$albumName = $albums[$j]['albumName'];//
					$albumName= sanitize($albums[$j]['albumName'], "html");
					$bandName = sanitize($albums[$j]['bandName'], "html");
					echo "<span class='myCol'>$bandName</span>";
					echo "<span class='myCol'>$albumName</span>";
					echo "</div>\n";
				}
			}
			
		}catch(PDOException $e){
			echo "Errors" . $e.getMessage();
		}
		echo "</div>\n";
	}
?>
<script>
	function setName(){
		var bandID = document.getElementById('bandID');
		if(bandID.selectedIndex == -1){
			return;
		}
		var bandName = bandID.options[bandID.selectedIndex].text;
		document.getElementById('bandName').value=bandName;
	}
</script>
</body>
</html>